#include <stdlib.h>
#include <stdio.h>
#include <unistd.h>
#include <sys/wait.h>
#include <libgen.h>
#include <ctype.h>
#include <sys/socket.h>
#include <signal.h>
#include "ohio.h"
int main (int ac, char* av[])
{
    int server_socket, sock, pid;
    config_t* config;
    
    if (ac < 2) {
        fprintf(stderr,"Usage: %s <DocumentPath> [port]\n",basename(av[0]));
        exit(EXIT_FAILURE);
    }
    
   daemonize(av[1]);
   signal(SIGCHLD, reapchild);

    config = malloc (sizeof(config_t));
    if(av[2]) {
        if (isdigit(av[2][0]))
            config->port = atoi(av[2]);
        else {
            fprintf(stderr, "Port must be a number\n");
            exit(EXIT_FAILURE);
        }
    }
    else config->port = 80;
    
    printf("Starting ohio... pid %d\n", getpid());
    server_socket = do_bind(config->port);
    listen(server_socket,5);
    while (1) {
        sock = accept(server_socket, NULL, 0);
        pid = fork();
        switch (pid) {
            case 0: /* fils */
                launch_web_server(sock);
                break;
            case -1: /* erreur */
                fprintf(stderr,"%s,%d : cannot fork\n", __FILE__, __LINE__);
            default: /* pere */
                /* done by signal handling
                wait(&status);  <- for debugging purpose (one child at a time)
                */
                close(sock); /* FIXME: not sure about that */
        }
    }
    exit(EXIT_SUCCESS);
}
