#include <stdlib.h>
#include <netinet/in.h>
#include <sys/types.h>
#include <sys/socket.h>
#include <string.h>
#include <stdio.h>

/* returns a socket binded to [port] */
int do_bind (int port)
{
    int sock;
    struct sockaddr_in sockname;
    int optval = -1;

    if ((sock = socket(PF_INET, SOCK_STREAM, 0)) < 0) {
        fprintf(stderr,"%s,%d : cannot open socket\n", __FILE__, __LINE__);
        exit (EXIT_FAILURE);
    }
    setsockopt (sock, SOL_SOCKET, SO_REUSEADDR, &optval, sizeof(int));

    memset ((char*)&sockname, 0, sizeof (struct sockaddr_in));
    sockname.sin_family = AF_INET;
    sockname.sin_port = htons(port);
    sockname.sin_addr.s_addr = htonl(INADDR_ANY);

    if (bind (sock, (struct sockaddr*) &sockname, sizeof(struct sockaddr_in)) < 0) {
        fprintf(stderr,"%s,%d : cannot bind\n", __FILE__, __LINE__);
        exit(EXIT_FAILURE);
    }
    return sock;
}
